# Immutable stacks -- all operations side-effect free

class Stack:

    def __init__(self, cont):
        self.__stack= cont

    def empty(): 
        return Stack([])

    def push(self, x):
        return Stack([x]+self.__stack)
        
    def top(self):
        return self.__stack[0]
    
    def pop(self):
        return Stack(self.__stack[1:])
        
    def isEmpty(self):
        return len(self.__stack) == 0
