# Mutable stacks -- push and pop have side effects

class Stack:

    # Implement a stack as a list.
    def __init__(self):
        self.__stack= []

    @staticmethod
    def empty():
        return Stack()

    def push(self, x):
        self.__stack= [x]+self.__stack
        return self

    def top(self):
        assert not self.isEmpty(), "'top' of empty stack"
        return self.__stack[0]
    
    def pop(self):
        assert not self.isEmpty(), "'pop' of empty stack"
        self.__stack= self.__stack[1:]
        return self
    
    def isEmpty(self):
        return len(self.__stack) == 0
