# Mutable stacks -- push and pop have side effects

class Stack:

    # Implement a stack using an array (as far as Python has them)  and a
    # stack pointer (not sure if this is more efficient than the list version).
    def __init__(self):
        self.__stack= []
        self.__stackptr= 0;

    @staticmethod
    def empty():
        return Stack()

    def push(self, x):
        if len(self.__stack) <= self.__stackptr:
          self.__stack += [None]*20
        self.__stack[self.__stackptr]= x
        self.__stackptr= self.__stackptr+1

    def top(self):
        assert self.__stackptr > 0, "'top' of empty stack"
        return self.__stack[self.__stackptr-1]
    
    def pop(self):
        assert self.__stackptr > 0, "'pop' of empty stack"
        self.__stackptr= self.__stackptr-1
        
    def isEmpty(self):
        return self.__stackptr == 0
    

    